#!/usr/bin/env python
#-*-coding:utf-8-*-

# "THE WISKEY-WARE LICENSE" (Revision 42):
# <jbc.develop@gmail.com> wrote this file. As long as you retain this notice you
# can do whatever you want with this stuff. If we meet some day, and you think
# this stuff is worth it, you can buy me a wiskey in return Juan BC

# recipe: http://code.activestate.com/recipes/414283-frozen-dictionaries/
# author: Ero Carrera

#===============================================================================
# DOC
#===============================================================================

"""An inmutable dictionary"""


#===============================================================================
# CLASS
#===============================================================================

class FrozenDict(dict):
   
    
    # > BLOCKED!!!! 
    def _blocked_attribute(self, *args, **kwargs):
        raise AttributeError("A Frozendict cannot be modified.")
        
    __delitem__ = __setitem__ = clear = _blocked_attribute
    pop = popitem = setdefault = update = _blocked_attribute
    # / BLOCKED!!!! 
   
    def __init__(self, *args, **kwargs):
        if kwargs:
            frozenset(kwargs.items())
        elif len(args) == 1 and isinstance(args[0], dict):
            frozenset(args[0].items())
        elif len(args) == 1 and hasattr(args[0], "__iter__"):
            frozenset(args[0])
        super(FrozenDict, self).__init__(*args, **kwargs)

    def __hash__(self):
        return hash(frozenset(self.items()))

    def __repr__(self):
        return "FrozenDict({})".format(dict.__repr__(self))
    
    def copy(self):
        return FrozenDict(super(FrozenDict, self).copy())
    
    @staticmethod
    def fromkeys(S, v=None):
        return FrozenDict(dict.fromkeys(S, v))
    



#===============================================================================
# MAIN
#===============================================================================

if __name__ == "__main__":
    print __doc__
