#!/usr/bin/env python
#-*-coding:utf-8-*-

# "THE WISKEY-WARE LICENSE" (Revision 42):
# <jbc.develop@gmail.com> wrote this file. As long as you retain this notice you
# can do whatever you want with this stuff. If we meet some day, and you think
# this stuff is worth it, you can buy me a wiskey in return Juan BC


#===============================================================================
# DOCS
#===============================================================================

"""Setup for infopython (http://bitbucket.org/leliel12/infopython)"""


#===============================================================================
# IMPORTS
#===============================================================================

import os

from ez_setup import use_setuptools
use_setuptools()

from setuptools import setup, find_packages
  

#===============================================================================
# CONSTANTS
#===============================================================================

METADATA_PATH = os.path.sep.join(
    (
        os.path.abspath(os.path.dirname(__file__)),
        "infopython",
        "_metadata.py"
    )
)

meta = {}
with open(METADATA_PATH) as fp:
    exec fp in meta
    
 
#===============================================================================
# SETUP
#===============================================================================

setup(
    name=meta["NAME"],
    version=meta["STR_VERSION"],
    description=meta["DESCRIPTION"],
    author=meta["AUTHOR"],
    author_email=meta["EMAIL"],
    url=meta["URL"],
    download_url=meta["DOWNLOAD_URL"],
    license=meta["LICENSE"],
    keywords=meta["KEYWORDS"],
    classifiers=meta["CLASSIFIERS"],
    packages=find_packages(),
    py_modules=["ez_setup", "test"],
    install_requires=meta["INSTALL_REQUIRES"],
    test_suite="test",
)


#===============================================================================
# MAIN
#===============================================================================

if __name__ == '__main__':
    print(__doc__)
