#!/usr/bin/env python
# -*- coding: utf-8 -*-

# "THE WISKEY-WARE LICENSE":
# <jbc.develop@gmail.com> wrote this file. As long as you retain this notice you
# can do whatever you want with this stuff. If we meet some day, and you think
# this stuff is worth it, you can buy me a WISKEY in return Juan BC

#===============================================================================
# DOC
#===============================================================================

"""Test for infopython.util.dttools

"""

#===============================================================================
# IMPORTS
#===============================================================================

import unittest
import datetime

from infopython.util import dttools


#===============================================================================
# TEST
#===============================================================================

class DTToolsFunctionTests(unittest.TestCase):
    
    def test_format(self):
        now = datetime.datetime.now()
        self.assertEqual(dttools.strftime(now), now.isoformat()) 
    
    def test_parse(self):
        now = datetime.datetime.now()
        dt = dttools.strptime(now.isoformat())
        self.assertEqual(dt.year, now.year)
        self.assertEqual(dt.month, now.month)
        self.assertEqual(dt.day, now.day)
        self.assertEqual(dt.hour, now.hour)
        self.assertEqual(dt.minute, now.minute)
        self.assertEqual(dt.second, now.second)
        self.assertEqual(dt.microsecond, now.microsecond)
        # remove microsecond
        dt = dttools.strptime(now.isoformat().rsplit(".", 1)[0])
        self.assertEqual(dt.year, now.year)
        self.assertEqual(dt.month, now.month)
        self.assertEqual(dt.day, now.day)
        self.assertEqual(dt.hour, now.hour)
        self.assertEqual(dt.minute, now.minute)
        self.assertEqual(dt.second, now.second)
        self.assertEqual(dt.microsecond, 0)
  
    
#===============================================================================
# MAIN
#===============================================================================

if __name__ == "__main__":
    print(__doc__)
