#!/usr/bin/env python
# -*- coding: utf-8 -*-

# "THE WISKEY-WARE LICENSE":
# <jbc.develop@gmail.com> wrote this file. As long as you retain this notice you
# can do whatever you want with this stuff. If we meet some day, and you think
# this stuff is worth it, you can buy me a WISKEY in return Juan BC

#===============================================================================
# DOC
#===============================================================================

"""Test for infopython.util.strtools

"""

#===============================================================================
# IMPORTS
#===============================================================================

import unittest
import random

from infopython.util import strtools


#===============================================================================
# TEST
#===============================================================================

class StrToolsFunctionTests(unittest.TestCase):
    
    def test_normalize(self):
        string = u"áàäâÁÀÄÂíìïîÍÌÏÎúùüûÚÙÜÛéèëêÉÈËÊóòôöÓÒÔÖñÑ"
        for l in set(strtools.normalize(string)):
            self.assertTrue(l in tuple("aeiueon"))
    
    def test_split_nonalpha(self):
        alphanum = list(
            u"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789"
        )
        joiners = list(u"%°!\"#$%&/()=?¡{}-.,][_:;")
        random.shuffle(alphanum)
        string = "".join([l + random.choice(joiners) for l in alphanum])
        for l in strtools.split_non_alpha(string):
            if l:
                self.assertTrue(l in alphanum)
  
    
#===============================================================================
# MAIN
#===============================================================================

if __name__ == "__main__":
    print(__doc__)
