#!/usr/bin/env python
# -*- coding: utf-8 -*-

# "THE WISKEY-WARE LICENSE":
# <jbc.develop@gmail.com> wrote this file. As long as you retain this notice you
# can do whatever you want with this stuff. If we meet some day, and you think
# this stuff is worth it, you can buy me a WISKEY in return Juan BC

#===============================================================================
# DOC
#===============================================================================

"""Test for infopython.util.xmlparser

"""

#===============================================================================
# IMPORTS
#===============================================================================

import unittest
import random
import sha
import datetime

from infopython.util import xmlparser


#===============================================================================
# TEST
#===============================================================================

class XMLParsersFunctionTests(unittest.TestCase):
    
    def setUp(self):
    
        generators = (
            lambda: None,
            lambda: bool(random.randint(0, 1)),
            lambda: str(random.random()),
            lambda: sha.sha(str(random.random())).hexdigest(),
            lambda: datetime.datetime.now(),
            lambda: list(sha.sha(str(random.random())).hexdigest()),
            lambda: tuple(sha.sha(str(random.random())).hexdigest()),
        )
    
        self.rd = {}
        for i in range(random.randint(1, 100)):
            self.rd[str(i)] = random.choice(generators)()
            
    def test_dump_load(self):
        parsed = xmlparser.loads(xmlparser.dumps(self.rd))
        self.assertEqual(parsed, self.rd)
        self.assertTrue(parsed is not self.rd)

    
#===============================================================================
# MAIN
#===============================================================================

if __name__ == "__main__":
    print(__doc__)
